Subject: Re: [RFC]: xfrm by mark

From: Patrick McHardy <[email-masked]>
Date: Mon, 08 Feb 2010 16:35:25 +0100

jamal wrote:
> On Mon, 2010-02-08 at 16:00 +0100, Patrick McHardy wrote:
> 
>> I'd prefer masks since the mark size is pretty small and its already
>> quite complicated to fit everything in 32 bit in complex setups.
>> We also support masks everywhere else (I believe) for mark values
>> nowadays.
> 
> I could still use the mask also as it is consistently 
> being used today i.e (mark & x->mask) == x->mark
> the only challenge i can think of is operational. How
> do you see me activating the use of these marks? The setups
> i see:
> 
> -By default if i use pfkey or old iproute2 i can have both
> mask and val as 0. no problem there..
> -If i was to insert table entries with say mark val 4 and mask 
> of 0, that would continue to work since mark is ignored.
> -if at some later point i want to use this mark 4, do i just change
> the mask? That may not scale well if you have a gazillion entries.
> If i used a sysctl all i would do is just turn on the
> syctl and the check becomes:
> syctl_use_mark && ((mark & x->mask) == x->mark)

Why would you want to insert entries with a mark and not use
them immediately? We don't support this anywhere without
replacing entries.